%% GM voxel intensities inside the clusters
function [results] = backpropagationwithVBMData (data_controles, data_pacientes)

   warning all off;

   per_group_subjects_no=49;
   k_de_kfold = 10;
   p = cvpartition(per_group_subjects_no,'kfold',k_de_kfold);
   c = cvpartition(per_group_subjects_no,'kfold',k_de_kfold);
   total_tests = 0;

   patient_label = -1;
   control_label =  1;

   for k=1:k_de_kfold

      training_data_controles = mapminmax(data_controles (training(c,k)==1,:));
      training_data_pacientes = mapminmax(data_pacientes (training(p,k)==1,:)); 
       
      [data label feat_no] = alignAndLabelDataForNN (training_data_controles, training_data_pacientes, control_label, patient_label);
      
      %creating neural network and training with training set
      bpnets(k).net = newff(minmax(data'), [5 1], {'logsig' 'purelin'}, 'trainlm');
      bpnets(k).net.trainParam.epochs     = 150;
      bpnets(k).net.trainParam.goal       = 0.01;
      bpnets(k).net.trainParam.showWindow = false;

      [trained_net, train_record] = train(bpnets(k).net, data', label');
      bpnets(k).net = trained_net;

      %compute classification of the test set
      test_data_controles     = mapminmax(data_controles (training(c,k)==0,:));
      test_data_pacientes     = mapminmax(data_pacientes (training(p,k)==0,:));

      [test_data test_label test_feat_no] = alignAndLabelDataForNN (test_data_controles, test_data_pacientes, control_label, patient_label);

      bpnet_results(k).output = transformaOutputsBackPropNN (sim (bpnets(k).net, test_data'));
      test_label = (test_label == 1);
      bpnet_results(k).target = test_label;

      [TP TN FP FN Accuracy Specificity Sensitivity] = computeErrors (bpnet_results(k).target', bpnet_results(k).output');
     
      bpnet_results(k).TP = TP;
      bpnet_results(k).TN = TN;
      bpnet_results(k).FP = FP;
      bpnet_results(k).FN = FN;

      bpnet_results(k).Accuracy    = Accuracy;
      bpnet_results(k).Specificity = Specificity;
      bpnet_results(k).Sensitivity = Sensitivity;

   end

   results = bpnet_results;
