%30/04/09
%alexandre manhaes savio <alexsavio@gmail.com>

%work with neural networks and AdaBoost with the results of VBM analysis with SPM5

%-- 4/29/09  5:52 PM --%

%concatenate voxel intensities of each cluster in a big matrix
%for s=1:size(voxels_pacientes,1);
%for c=1:2:size(voxels_pacientes,2);
%   kk=horzcat(voxels_pacientes(s,c).voxels', voxels_pacientes(s,c+1).voxels');
%   if (c~=1); aux=horzcat(kk,aux);
%   else;      aux=kk;
%end;


%for i=1:size(mean_stddev_controles,1);
%	mean_stddev_matrix_controles (i,:) = reshape (mean_stddev_controles(i,:,:), 1, (size(mean_stddev_controles,2)*size(mean_stddev_controles,3)) );
%end;
%for i=1:size(mean_stddev_pacientes,1);
%	mean_stddev_matrix_pacientes (i,:) = reshape (mean_stddev_pacientes(i,:,:), 1, (size(mean_stddev_pacientes,2)*size(mean_stddev_pacientes,3)) );
%end;

%k=1; mean_acc (k,:) = Mean_Accuracy; std_acc(k,:)=Std_Accuracy; mean_spec(k,:)=Mean_Specificity; std_spec(k,:)=Std_Specificity; mean_sens(k,:)=Mean_Sensitivity; std_sens(k,:)=Std_Sensitivity;

%%===============================================================================
%%Loading data
'Loading data'

load datos_vbm_procesados_para_neuralnets.mat

%%===============================================================================
%%Probabilistic Neural Network For Mean and StdDev
'Probabilistic Neural Network For Mean and StdDev'

Times        =    1;
spread_coeff = 0.22;
%0.19

for times=1:Times;
   results                  = probabilisticNNwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes, spread_coeff);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))

Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))

Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Probabilistic Neural Network For Voxel Intensities
'Probabilistic Neural Network For Voxel Intensities'

Times        =    1;
spread_coeff = 0.44;

for times=1:Times;
   results                  = probabilisticNNwithVBMData (voxels_matrix_controles, voxels_matrix_pacientes, spread_coeff);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))

Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))

Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Probabilistic Neural Network For GM Proportions
'Probabilistic Neural Network For GM Proportions'

Times        =    1;
spread_coeff = 0.16;

for times=1:Times;
   results                  = probabilisticNNwithVBMData (gm_proportion_controles, gm_proportion_pacientes, spread_coeff);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))

Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))

Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Radial Basis Networks with VBM For Mean and StdDev
'Radial Basis Networks with VBM For Mean and StdDev'

Times        = 1;
spread_coeff = 0.02;

for times=1:Times;
   results                  = radialBasisNNwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes, spread_coeff);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))

Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))

Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Radial Basis Networks with VBM For Voxel Intensities
'Radial Basis Networks with VBM For Voxel Intensities'

Times        =     1;
spread_coeff = 0.852;
%0.566

for times=1:Times;
   results                  = radialBasisNNwithVBMData (voxels_matrix_controles, voxels_matrix_pacientes, spread_coeff);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))

Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))

Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Radial Basis Network For GM Proportions
'Radial Basis Network For GM Proportions'

Times        =     1;
spread_coeff = 0.014;

for times=1:Times;
   results                  = radialBasisNNwithVBMData (gm_proportion_controles, gm_proportion_pacientes, spread_coeff);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))

Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))

Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Back Propagation Networks with VBM For Mean and StdDev
% 'Back Propagation Networks with VBM For Mean and StdDev'
% 
% Times = 1;
% 
% for times=1:Times;
%    results                  = backpropagationwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes);
%    Accuracies    (times, :) = [results.Accuracy   ];
%    Specificities (times, :) = [results.Specificity];
%    Sensitivities (times, :) = [results.Sensitivity];
% end;
% 
% Std_Accuracy     = std  (Accuracies   (:))
% Std_Specificity  = std  (Specificities(:))
% Std_Sensitivity  = std  (Sensitivities(:))
% 
% Var_Accuracy     = var  (Accuracies   (:))
% Var_Specificity  = var  (Specificities(:))
% Var_Sensitivity  = var  (Sensitivities(:))
% 
% Mean_Accuracy    = mean (Accuracies   (:))
% Mean_Specificity = mean (Specificities(:))
% Mean_Sensitivity = mean (Sensitivities(:))
% 
% clear Accuracies Specificities Sensitivities


%%===============================================================================
% %%Back Propagation Networks with VBM For Voxel Intensities
% 'Back Propagation Networks with VBM For Voxel Intensities'
% 
% Times = 1;
% 
% for times=1:Times;
%    results                  = backpropagationwithVBMData (voxels_matrix_controles, voxels_matrix_pacientes);
%    Accuracies    (times, :) = [results.Accuracy   ];
%    Specificities (times, :) = [results.Specificity];
%    Sensitivities (times, :) = [results.Sensitivity];
% end;
% 
% Std_Accuracy     = std  (Accuracies   (:))
% Std_Specificity  = std  (Specificities(:))
% Std_Sensitivity  = std  (Sensitivities(:))
% 
% Var_Accuracy     = var  (Accuracies   (:))
% Var_Specificity  = var  (Specificities(:))
% Var_Sensitivity  = var  (Sensitivities(:))
% 
% Mean_Accuracy    = mean (Accuracies   (:))
% Mean_Specificity = mean (Specificities(:))
% Mean_Sensitivity = mean (Sensitivities(:))
% 
% clear Accuracies Specificities Sensitivities

%%===============================================================================
%%Back Propagation Networks with VBM For Mean and StdDev
% 'Back Propagation Networks with VBM For GM Proportion'
% 
% Times = 1;
% 
% for times=1:Times;
%    results                  = backpropagationwithVBMData (gm_proportion_controles, gm_proportion_pacientes);
%    Accuracies    (times, :) = [results.Accuracy   ];
%    Specificities (times, :) = [results.Specificity];
%    Sensitivities (times, :) = [results.Sensitivity];
% end;
% 
% Std_Accuracy     = std  (Accuracies   (:))
% Std_Specificity  = std  (Specificities(:))
% Std_Sensitivity  = std  (Sensitivities(:))
% 
% Var_Accuracy     = var  (Accuracies   (:))
% Var_Specificity  = var  (Specificities(:))
% Var_Sensitivity  = var  (Sensitivities(:))
% 
% Mean_Accuracy    = mean (Accuracies   (:))
% Mean_Specificity = mean (Specificities(:))
% Mean_Sensitivity = mean (Sensitivities(:))
% 
% clear Accuracies Specificities Sensitivities
% 

%%===============================================================================
%%Learning Vector Quantization Networks with VBM For Mean and StdDev
% 'Learning Vector Quantization Networks with VBM For Mean and StdDev'
% 
Times = 10;

for times=1:Times;
   results                  = LVQwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes);
   Accuracies    (times, :) = [results.Accuracy   ];
   Specificities (times, :) = [results.Specificity];
   Sensitivities (times, :) = [results.Sensitivity];
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))
 
Var_Accuracy     = var  (Accuracies   (:))
Var_Specificity  = var  (Specificities(:))
Var_Sensitivity  = var  (Sensitivities(:))
 
Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))
% 
% clear Accuracies Specificities Sensitivities
% 

%%===============================================================================
%%Learning Vector Quantization Networks with VBM For Voxel Intensities
% 'Learning Vector Quantization Networks with VBM For Voxel Intensities'
% 
% 
% Times = 1;
% 
% for times=1:Times;
%    results                  = LVQwithVBMData (voxels_matrix_controles, voxels_matrix_pacientes);
%    Accuracies    (times, :) = [results.Accuracy   ];
%    Specificities (times, :) = [results.Specificity];
%    Sensitivities (times, :) = [results.Sensitivity];
% end;
% 
% Std_Accuracy     = std  (Accuracies   (:))
% Std_Specificity  = std  (Specificities(:))
% Std_Sensitivity  = std  (Sensitivities(:))
% 
% Var_Accuracy     = var  (Accuracies   (:))
% Var_Specificity  = var  (Specificities(:))
% Var_Sensitivity  = var  (Sensitivities(:))
% 
% Mean_Accuracy    = mean (Accuracies   (:))
% Mean_Specificity = mean (Specificities(:))
% Mean_Sensitivity = mean (Sensitivities(:))
% 
% clear Accuracies Specificities Sensitivities
% 

%%===============================================================================
%%Learning Vector Quantization Networks with VBM For GM Proportion
% 'Learning Vector Quantization Networks with VBM For GM Proportion'
% 
% Times = 1;
% 
% for times=1:Times;
%    results                  = LVQwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes);
%    Accuracies    (times, :) = [results.Accuracy   ];
%    Specificities (times, :) = [results.Specificity];
%    Sensitivities (times, :) = [results.Sensitivity];
% end;
% 
% Std_Accuracy     = std  (Accuracies   (:))
% Std_Specificity  = std  (Specificities(:))
% Std_Sensitivity  = std  (Sensitivities(:))
% 
% Var_Accuracy     = var  (Accuracies   (:))
% Var_Specificity  = var  (Specificities(:))
% Var_Sensitivity  = var  (Sensitivities(:))
% 
% Mean_Accuracy    = mean (Accuracies   (:))
% Mean_Specificity = mean (Specificities(:))
% Mean_Sensitivity = mean (Sensitivities(:))
% 
% clear Accuracies Specificities Sensitivities
% 

%%===============================================================================
%%Probabilistic Neural Network For Mean and StdDev
'Probabilistic Neural Network For Different characteristics CHECK ALL SPREADS'

Times        = 1;
spread_coeff = 0;

for s=1:500
   spread_coeff = spread_coeff + 1/500;

   for times=1:Times;
%     results                  = probabilisticNNwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes, spread_coeff);
%     results                  = probabilisticNNwithVBMData (voxels_matrix_controles, voxels_matrix_pacientes, spread_coeff);
     results                  = probabilisticNNwithVBMData (gm_proportion_controles, gm_proportion_pacientes, spread_coeff);

%      results                  = radialBasisNNwithVBMData (mean_stddev_matrix_controles, mean_stddev_matrix_pacientes, spread_coeff);
%      results                  = radialBasisNNwithVBMData (voxels_matrix_controles, voxels_matrix_pacientes, spread_coeff);
%      results                  = radialBasisNNwithVBMData (gm_proportion_controles, gm_proportion_pacientes, spread_coeff);

      Accuracies    (times, :) = [results.Accuracy   ];
      Specificities (times, :) = [results.Specificity];
      Sensitivities (times, :) = [results.Sensitivity];
   end;

   Std_Accuracy    (s) = std  (Accuracies   (:))
   Std_Specificity (s) = std  (Specificities(:))
   Std_Sensitivity (s) = std  (Sensitivities(:))

   Var_Accuracy    (s) = var  (Accuracies   (:))
   Var_Specificity (s) = var  (Specificities(:))
   Var_Sensitivity (s) = var  (Sensitivities(:))

   Mean_Accuracy   (s) = mean (Accuracies   (:))
   Mean_Specificity(s) = mean (Specificities(:))
   Mean_Sensitivity(s) = mean (Sensitivities(:))

   Spread_Coeffs   (s) = spread_coeff;

   clear Accuracies Specificities Sensitivities

end;


%%===============================================================================
%%Probabilistic Neural Network AdaBoost varying SPREAD
%'Probabilistic Neural Network AdaBoost varying SPREAD'

%Times = 1;

%for times=1:Times;
%   results                = ProbabilisticNN_AdaBoost_Varying_Spread ();
%   Mean_Accuracy   (times) = mean([results.Accuracy   ]);
%   Mean_Specificity(times) = mean([results.Specificity]);
%   Mean_Sensitivity(times) = mean([results.Sensitivity]);


%   Min_Accuracy   (times)  = min ([results.Accuracy]   );
%   Min_Specificity(times)  = min ([results.Specificity]);
%   Min_Sensitivity(times)  = min ([results.Sensitivity]);

%   Max_Accuracy   (times)  = max ([results.Accuracy]   );
%   Max_Specificity(times)  = max ([results.Specificity]);
%   Max_Sensitivity(times)  = max ([results.Sensitivity]);

%end;

%Var_Accuracy     = max (Max_Accuracy   ) - min (Min_Accuracy   )
%Var_Specificity  = max (Max_Specificity) - min (Min_Specificity)
%Var_Sensitivity  = max (Max_Sensitivity) - min (Min_Sensitivity)

%Mean_Accuracy    = mean (Mean_Accuracy   )
%Mean_Specificity = mean (Mean_Specificity)
%Mean_Sensitivity = mean (Mean_Sensitivity)

% clear Accuracies Specificities Sensitivities

%%===============================================================================
%%SVM with VBM For Mean and StdDev
% 
% 
Times = 10;

for times=1:Times;
   [Acc Spec Sens] = SVM_MeanAndStdDev;
   Accuracies    (times, :) = Acc;
   Specificities (times, :) = Spec;
   Sensitivities (times, :) = Sens;
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))
 
Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

clear Accuracies Specificities Sensitivities

%%===============================================================================
%%SVM with VBM For Voxel Intensities
% 
%
Times = 10;

for times=1:Times;
   [Acc Spec Sens] = SVM_VoxelIntensities;
   Accuracies    (times, :) = Acc;
   Specificities (times, :) = Spec;
   Sensitivities (times, :) = Sens;
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))
 
Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

%%===============================================================================
%%Majority Voting SVM with VBM For Voxel Intensities
% 
%
load ../data/3-spm_and_wm_subjects_and_extracted_feats.mat
Times = 10;

for times=1:Times;
   [Acc Spec Sens] = SVMVoting_VoxelIntensities (voxels_per_cluster_C, voxels_per_cluster_P, SPM);
   Accuracies    (times, :) = Acc;
   Specificities (times, :) = Spec;
   Sensitivities (times, :) = Sens;
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))
 
Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

%%===============================================================================
%%Majority Voting SVM with VBM For Mean and StdDev
% 
%
load ../data/3-spm_and_wm_subjects_and_extracted_feats.mat
Times = 10;
data_controls = meanstd_C;
data_patients = meanstd_P;

for times=1:Times;
   [Acc Spec Sens] = SVMVoting_MeanAndStdDev (meanstd_C, meanstd_P, SPM);
   Accuracies    (times, :) = Acc;
   Specificities (times, :) = Spec;
   Sensitivities (times, :) = Sens;
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))
 
Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

%%===============================================================================
%%Weighted SVM with VBM For Mean and StdDev
% 
%
load ../data/3-spm_and_wm_subjects_and_extracted_feats.mat
Times = 10;
data_controls = meanstd_C;
data_patients = meanstd_P;

for times=1:Times;
   [Acc Spec Sens] = ClusterSVM_AdaBoost (WM_CONTROLS, WM_PATIENTS, SPM);
   Accuracies    (times, :) = Acc;
   Specificities (times, :) = Spec;
   Sensitivities (times, :) = Sens;
end;

Std_Accuracy     = std  (Accuracies   (:))
Std_Specificity  = std  (Specificities(:))
Std_Sensitivity  = std  (Sensitivities(:))
 
Mean_Accuracy    = mean (Accuracies   (:))
Mean_Specificity = mean (Specificities(:))
Mean_Sensitivity = mean (Sensitivities(:))

