%% GM voxel intensities inside the clusters
function [results] = radialBasisNNwithVBMData (data_controles, data_pacientes, spread_coeff)

   per_group_subjects_no=49;
   k_de_kfold = 10;
   p = cvpartition(per_group_subjects_no,'kfold',k_de_kfold);
   total_tests = 0;

   patient_label = -1;
   control_label =  1;

   for k=1:k_de_kfold

      training_data_controles = data_controles (training(p,k)==1,:);
      training_data_pacientes = data_pacientes (training(p,k)==1,:); 
       
      [data label feat_no] = alignAndLabelDataForNN (training_data_controles, training_data_pacientes, control_label, patient_label);
      
      %creating neural network and training with training set
      rbnets (k).net = newgrnn (data', label', spread_coeff);

      %compute classification of the test set
      test_data_controles     = data_controles (training(p,k)==0,:);
      test_data_pacientes     = data_pacientes (training(p,k)==0,:);

      [test_data test_label test_feat_no] = alignAndLabelDataForNN (test_data_controles, test_data_pacientes, control_label, patient_label);

      %interpretar datos de salida de la radial basis network
      output      = sim (rbnets (k).net, test_data');
      idx         = find (output < 0);
      output(idx) = -1;
      aux         = output > 0;
      output      = aux + output;      

      %save results
      rbnet_results(k).output = output;
      rbnet_results(k).target = test_label;

      [TP TN FP FN Accuracy Specificity Sensitivity] = computeErrors (rbnet_results(k).target', rbnet_results(k).output);
     
      rbnet_results(k).TP = TP;
      rbnet_results(k).TN = TN;
      rbnet_results(k).FP = FP;
      rbnet_results(k).FN = FN;
      rbnet_results(k).Accuracy = Accuracy;
      rbnet_results(k).Specificity = Specificity;
      rbnet_results(k).Sensitivity = Sensitivity;

   end

   results = rbnet_results;
